option explicit

Dim args
set args = WScript.Arguments

if args.Count <> 3 then
	MsgBox WScript.ScriptName & ": Wrong number of arguments. Give the target folder, the dir-list file, and the sub-dir-list file as arguments."
	WScript.Quit 1
end if

Dim DestPath
DestPath = args.Item(0)

Dim DirsFilePath
DirsFilePath = args.Item(1)

Dim SubdirsFilePath
SubdirsFilePath = args.Item(2)

'Dim outputFile
'outputFile = args.Item(1)
'MsgBox("Search String: " & searchString)

Dim reIllegalFileChars
Set reIllegalFileChars = New RegExp
reIllegalFileChars.Global = True
reIllegalFileChars.IgnoreCase = True
reIllegalFileChars.Pattern = "[<>:""/\|?*]"

Dim fs
Set fs = CreateObject("Scripting.FileSystemObject")

Dim shell
Set shell = CreateObject("WScript.Shell")


Dim SubdirArray()
Dim SubdirArraySize
Dim Subdir
Dim SubdirsFile
Set SubdirsFile = fs.OpenTextFile(SubdirsFilePath, 1, False, 0)

SubdirArraySize = 0
Do While Not SubdirsFile.AtEndOfStream
	Subdir = reIllegalFileChars.Replace( Trim( SubdirsFile.ReadLine() ), "_" )
	If Len(Subdir) > 0 Then
		ReDim Preserve SubdirArray(SubdirArraySize)
		SubdirArray(SubdirArraySize) = Subdir
		SubdirArraySize = SubdirArraySize + 1
	End If
Loop
SubdirsFile.Close

Dim SubdirIdx
Dim DirPath
Dim SubdirPath
Dim TopdirName
Dim TopdirNamesFile
Set TopdirNamesFile = fs.OpenTextFile(DirsFilePath, 1, False, 0)

Do While Not TopdirNamesFile.AtEndOfStream
	TopdirName = reIllegalFileChars.Replace( Trim( TopdirNamesFile.ReadLine() ), "_" )
	If Len(TopdirName) > 0 Then
		DirPath = fs.BuildPath(DestPath, TopdirName)
		If Not fs.FolderExists(DirPath) Then
			fs.CreateFolder(DirPath)
		End If
		For SubdirIdx = 0 To SubdirArraySize - 1
			SubdirPath = fs.BuildPath(DirPath, SubdirArray(SubdirIdx))
			If Not fs.FolderExists(SubdirPath) Then
				fs.CreateFolder(SubdirPath)
			End If
		Next
	End If
Loop
TopdirNamesFile.Close
